Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.nio.channels
Class ServerSocketChannel

    java.lang.Object
      |
      +--java.nio.channels.spi.AbstractInterruptibleChannel
            |
            +--java.nio.channels.SelectableChannel
                  |
                  +--java.nio.channels.spi.AbstractSelectableChannel
                        |
                        +--java.nio.channels.ServerSocketChannel

All Implemented Interfaces:
  Channel, InterruptibleChannel

public abstract class ServerSocketChannel
extends AbstractSelectableChannel

A selectable channel for stream-oriented listening sockets.

Server-socket channels are not a complete abstraction of listening network sockets. Binding and the manipulation of socket options must be done through an associated `ServerSocket` object obtained by invoking the `socket` method. It is not possible to create a channel for an arbitrary, pre-existing server socket, nor is it possible to specify the `SocketImpl` object to be used by a server socket associated with a server-socket channel.

A server-socket channel is created by invoking the `open` method of this class. A newly-created server-socket channel is open but not yet bound. An attempt to invoke the `accept` method of an unbound server-socket channel will cause a `NotYetBoundException` to be thrown. A server-socket channel can be bound by invoking one of the `bind` methods of an associated server socket.

Server-socket channels are safe for use by multiple concurrent threads.

Since:
  1.4

Constructor Summary
`protected` | `ServerSocketChannel(SelectorProvider provider)` Initializes a new instance of this class.

Method Summary
`abstract SocketChannel` | `accept()` Accepts a connection made to this channel's socket.
`static ServerSocketChannel` | `open()` Opens a server-socket channel.
`abstract ServerSocket` | `socket()` Retrieves a server socket associated with this channel.
`int` | `validOps()` Returns an operation set identifying this channel's supported operations.

Methods inherited from class java.nio.channels.spi.AbstractSelectableChannel
`blockingLock, configureBlocking, implCloseChannel, implCloseSelectableChannel, implConfigureBlocking, isBlocking, isRegistered, keyFor, provider, register`

Methods inherited from class java.nio.channels.SelectableChannel
`register`

Methods inherited from class java.nio.channels.spi.AbstractInterruptibleChannel
`begin, close, end, isOpen`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.nio.channels.Channel
`close, isOpen`

Constructor Detail

### ServerSocketChannel

    protected ServerSocketChannel(SelectorProvider provider)

  Initializes a new instance of this class.

Method Detail

### open

    public static ServerSocketChannel open()
                                    throws IOException

  Opens a server-socket channel.

  The new channel is created by invoking the `openServerSocketChannel` method of the system-wide default `SelectorProvider` object.

  The new channel's socket is initially unbound; it must be bound to a specific address via one of its socket's `bind` methods before connections can be accepted.

  Returns:
    A new socket channel
  Throws:
    `IOException` - If an I/O error occurs

### validOps

    public final int validOps()

  Returns an operation set identifying this channel's supported operations.

  Server-socket channels only support the accepting of new connections, so this method returns `SelectionKey.OP_ACCEPT`.

  Specified by:
    `validOps` in class `SelectableChannel`
  Returns:
    The valid-operation set

### socket

    public abstract ServerSocket socket()

  Retrieves a server socket associated with this channel.

  The returned object will not declare any public methods that are not declared in the `ServerSocket` class.

  Returns:
    A server socket associated with this channel

### accept

    public abstract SocketChannel accept()
                                  throws IOException

  Accepts a connection made to this channel's socket.

  If this channel is in non-blocking mode then this method will immediately return `null` if there are no pending connections. Otherwise it will block indefinitely until a new connection is available or an I/O error occurs.

  The socket channel returned by this method, if any, will be in blocking mode regardless of the blocking mode of this channel.

  This method performs exactly the same security checks as the `accept` method of the `ServerSocket` class. That is, if a security manager has been installed then for each new connection this method verifies that the address and port number of the connection's remote endpoint are permitted by the security manager's `checkAccept` method.

  Returns:
    The socket channel for the new connection, or `null` if this channel is in non-blocking mode and no connection is available to be accepted
  Throws:
    `ClosedChannelException` - If this channel is closed
    `AsynchronousCloseException` - If another thread closes this channel while the accept operation is in progress
    `ClosedByInterruptException` - If another thread interrupts the current thread while the accept operation is in progress, thereby closing the channel and setting the current thread's interrupt status
    `NotYetBoundException` - If this channel's socket has not yet been bound
    `SecurityException` - If a security manager has been installed and it does not permit access to the remote endpoint of the new connection
    `IOException` - If some other I/O error occurs

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.